<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?php
class Products_Orders {
	
	private $db;
	private $dbname = 'goods_orders';
	private $dbname_status_log = 'orders_status_log';
	private $deliveries;

	public function __construct() {
		
	
		$this ->db = Core_Database::getInstance();	
		$this-> db2 =  MysqliDb::getInstance();
		$this->lang = Core_Language::getInstance()->getCurrentLanguage();
		$this->lang_id = Core_Language::getInstance()->getCurrent();

		$this->shipping_methods= Products_Delivery::getInstance()->getList();

		$this->admin_auth  = new Admin_User;
		//$this->admin_id = $this->admin_auth->GetID();
		
		$this->payments  = array(
				1=>getVar('cash'),
				2=>getVar('bank_transfer'),
				3=>getVar('payment_card')
				);

		$this->deliveries = Products_Delivery::getInstance()->getList();
		
			$this->status = array(
			 0 => getVar('STATUS_PROCESSING'), 
			1 => getVar('STATUS_FINISHED'),
			2 => getVar('STATUS_CANCELED'), 
			 3 => getVar('STATUS_PAID'), 
			 4 => getVar('STATUS_PICKUP'), 
			5 => getVar('STATUS_SHIPPING'),
			6 => getVar('STATUS_AWAITING_PAYMENT'),
		 );  

		 $this->status_order = array(0=>1,6=>2,3=>3,4=>4,5=>5,1=>6,2=>7);

		 $this->statusAliases = array(
			 0 => 'processing',
			1 => 'finished',
			2 => 'cancelled',	
			 3 => 'paid',
			4 =>  'pickup',
			 5 => 'shipping',
			6 => 'awaiting_payment' 
	 
										   
		 );  

		 $this->cancelReasons = array(

			 1=> getVar('products_not_available'),	
			 2=> getVar('requested_by_client'),	
			 3=> getVar('payment_term_expired'),
			 4=> getVar('client_is_not_responding')

		 );

		 $this->cancelClientReasons = array(

			 1=> getVar('error_in_order'),	
			 2=> getVar('products_no_longer_needed'),	
			 3=> getVar('found_cheaper'),	
		 );

		 $this->orders_notifications = array(

			1 => 'order_finished',
			 3 => 'order_paid',
			 4 => 'order_pickup',
			5 => 'order_shipping',
			6 => 'order_awaiting_payment'
			
		 );

		 $this->finished = 1;
		 $this->cancelled = 2;
		 $this->paid = 3;
		 $this->shipping = 4;

		$this->payment_term = 3;

		 $this->status_info = array(
			 3=>array('modal_url'=>'form_status_shipping'),
			 9=>array('modal_url'=>'form_status_finished'),
			 10=>array('modal_url'=>'form_status_cancel')

		 );

		$this->paymentStatuses = Payments_Payments::getInstance()->getStatusList();
		$this->status_colors = array(0 => '#96be25', 1 => '#2587be', 2 => '#dc5557', 3 => '#55dcda',4 => '#c3dc55',  5 => '#9655dc', 6=>'#e28743');



	}
	public function getShippingMethods() {
	
		$array = $this->db2->map('id')->get('delivery');
		foreach($array as $key => $row) {

			$array[$key]['name'] = getVar($row['code']);


		}

		return $array;
	}	

	public function getProgress($order_id) {

		$order = $this->getOrder($order_id);

		if($order['is_cancelled']) return;

		$classes = array(0=>'zero','1'=>'one',2=>'two',3=>'three',4=>'four');

		$steps[1]  = array(

			0=>'processing',
			1=>'awaiting_payment',
			2=>'paid',
			3=>'pickup',
			4=>'finished',
		);

		$steps[2]  = array(

			0=>'processing',
			1=>'awaiting_payment',
			2=>'paid',
			3=>'shipping',
			4=>'finished',
		);

		$steps[3]  = array(

			0=>'processing',
			1=>'awaiting_payment',
			2=>'paid',
			3=>'shipping',
			4=>'finished',
		);

		$log = $this->db2->orderBy('time','ASC')
						->map('status_id')
						->where('order_id',$order_id)
						->get($this->dbname_status_log);
		
		$first_entry = reset($log);					

		$current_step = 0;
		$default_time = strtotime($order['date']);

		foreach($steps[$order['delivery']] as $step =>$alias) {	


				$id = array_search($alias, $this->statusAliases);

				$item = array('name'=>$this->status[$id],'class'=>$classes[$step]);
						
				if($order['status']==$id) {					
					$item['current'] = 1;
					$current_step = $step;
					$item['time'] = date('d.m.y H:i',$default_time);
				} else {
					$item['current'] = 0;
				}

				if(isset($log[$id]) && $id<=$order['status'])				
					$item['time']=date('d.m.y H:i',$log[$id]['time']);

				$items[]=$item;
		}


		$return['items'] = $items;
		$return['progress'] = round(($current_step)/(count($items)-1)*100);
	

		if($return['progress']<100)
			$return['progress']+=5;

		return $return;

	
	}	


	public function getPaymentMethods() {

		$array = $this->db2->map('id')->get('payment_methods');

		foreach($array as $key => $row) {
			$array[$key]['name'] = getVar($row['code']);
		}

		return $array;
	
}	

public function send_status($order_id, $status) { 

	$shipping = $this->getShippingMethods();
	$payments = $this->getPaymentMethods();	

	$order = $this->getOrder($order_id);

	$template = isset($this->orders_notifications[$status]) ? $this->orders_notifications[$status] : 0;

	if($template) {

		$order_url = SERVER.'/orders/view.php?id='.$order['number'];

		$template_id = emailTemplates::getInstance()->getID($template);

		$data = emailTemplates::getInstance()->getTemplate($template_id,$order ['def_lang']);   

		//print_r($order);

		$data['text']=str_replace('%%person_name%%',$order['name'],$data['text']);
		
		$data['text']=str_replace('%%order_nr%%',$order['number'],$data['text']);

		$data['text']=str_replace('%%order_url%%',$order_url,$data['text']);

		// Order confirm
		$data['text']=str_replace('%%products_table%%',$this->getProductsTable($order,$order['def_lang']),$data['text']);

		// PAID

		$payment = $this->getPaymentMethod($order['payment'],$order['def_lang']);
		$shipping_name = $this->getShippingName($order['delivery'],$order['def_lang']);	
		
		if($order['paid'])
		$data['text']=str_replace('%%payment_date%%',date('d.m.y H:i',$order['paid']),$data['text']);
		
		$data['text']=str_replace('%%payment_term%%',$order['payment_date'],$data['text']);
		
		
		$data['text']=str_replace('%%amount%%',$order['total'],$data['text']);
		
			
		$data['text']=str_replace('%%payment_method%%',$payment['name'],$data['text']);
			
		$data['text']=str_replace('%%delivery_method%%',$shipping_name,$data['text']);
		
		if(!empty($order['delivery_data']))
		$data['text']=str_replace('%%shipping_date%%',$order['delivery_data']['shipping'],$data['text']);
		

			// Delivery
		$data['text']=str_replace('%%delivery_method%%',$order['shipping_method']['name'],$data['text']);
		$data['text']=str_replace('%%delivery_address%%',$order['delivery_address'],$data['text']);
		
		/* $data['text']=str_replace('%%courier%%',$order['courier_name'],$data['text']); */
		$data['text']=str_replace('%%tracking_number%%',$order['shipping_tracking_number'],$data['text']);
		

		// Pickup 
		$data['text']=str_replace('%%warehouse_address%%',$order['value'],$data['text']);
		$data['text']=str_replace('%%warehouse_map_url%%',SERVER.'/contact/warehouse',$data['text']);
	
		// Invoice

		$data['text']=str_replace('%%invoice_url%%',SERVER.'/order/invoice.php?id='.$order['number'],$data['text']);
		 $data['text']=str_replace('%%payment_date%%',$order['payment_term'].' '.getVar('days',$order['def_lang']).' - '.$order['payment_date'],$data['text']);
		 $data['text']=str_replace('%%amount%%',$order['total'],$data['text']);
		 $data['text']=str_replace('%%payment_url%%',SERVER.'/order/?id='.$order['number'].'&page=payment',$data['text']);

		// Finished

		/* $feedback_url = '<a class="button" href="'.SERVER.'/order/feedback/'.$order['nomer'].'">'.getVar('leave_feedback_btn',$order['def_lang']).'</a>';
		$data['text']=str_replace('%%special_offer%%','',$data['text']);
		$data['text']=str_replace('%%feedback%%',$feedback_url,$data['text']);
		*/	
			
		 $data['subject']=str_replace('%%order_nr%%',$order['number'],$data['subject']);

		//$user = users::getInstance()->get_user($order['id_user']);   

		$data['name'] = $order['name'];
		$data['email'] = $order['email'];

						
		$data['text'] = Tools_Email::emailBody($data['text']);
		$result = Tools_Email::sendMail($data['email'],$data['subject'],$data['text'],1);	
		
		return $result;


	}	

}	

public function updateOrder($id,$field,$value) {

		if($id && $field) {
		
			$input = array();
			$input[$field] = $value;
			$this->db2->where('id',$id);
			return $this->db2->update($this->dbname,$input);
		
		}


	}

	public function changeStatus($order_id,$status_id) {
							 
		$result = $this->setStatus($order_id,$status_id);

		/* $data = $this->getOrder($order_id);

		if(!$data['manager_id'])				
			$this->setManager($order_id); */

		if($result) {
			$this->logStatus($order_id,$status_id);
			 $this->send_status($order_id,$status_id);
		 }	
		 
		 return $result;

	}		

	public function logStatus($order_id,$status_id) {
						
		$input = array();
		$input['order_id'] = $order_id; 
		$input['status_id'] = $status_id; 
		$input['user_id'] = 0;
		$input['time'] = time();

		return $this->db2->insert('orders_status_log',$input);						

	}



	public function setStatus($order_id,$status_id) {

		$input = array();
		$input['status']= $status_id;							
		$this->db2->where('id',$order_id);										
		return $this->db2->update($this->dbname,$input);		
	}	

	public function getOrderTemplate ($lang_id='1') {

		$query = "SELECT * FROM email_templates WHERE template_id='2' AND lang_id='".$lang_id."' ";            	
	  $data = $this -> db -> GetArray($query);  
  
	  return $data[0]; 
	  
	}       	
		   
	
	
	function getSMSTemplate ($lang_id='lv') {
			
		$sql = "SELECT * FROM email_templates WHERE alias='sms_order' AND lang_id='".$lang_id."' ";            	
	  $data = $this -> db -> getArray($sql);   			   	
	  return $data[0]['text']; 
	  
	
   } 

	 public function sendOrder($id,$lang_id=1,$email='') { 
	 

		$text = $this->getOrderTemplate($lang_id);	 			 		
		$data = $this->getOrder($id);


	  if($email)
		  $data['email'] = $email;
	   
		
		$subject = str_replace('%%order_number%%',$data['number'],$text['subject']); 
		$body = str_replace('%%order_number%%',$data['number'],$text['text']);
		
		
		$client_details[] = $data['name'].' '.$data['surname'];
	   
	   
	   $L = Core_Language::getInstance();
	   
	   
	   if($data['delivery']>1)
			$client_details[] = $data['shipping_method']['name'].': '.$data['delivery_address'];
	   else
		   $client_details[] = $data['delivery_address'].': '.$data['value'];
	   
	   if($data['client_card'])    
		   $client_details[] = $L->Str('Card_clients').': '.$data['client_card'];
								
	   $client_details_text = implode('<br />',$client_details);
		$body = str_replace('%%client_details%%',$client_details_text,$body);
		
		$order_items  ='<div style="padding:10px 0px"><b>'.$L->Str('Products').':</b></div>';

		$order_items  .='<table style="width:800px;">';
		$total = 0;

		
		if(!empty($data['products']))
		foreach($data['products'] as $item) {
			
			$total_prod = $item['price']*$item['count'];	
			 $total +=  $total_prod; 
		  
			  
			$order_items  .='<tr>';
			$order_items  .='<td>'.$L->StrT('goods','title', $item['id'], $item['title']) .'</td>';
			$order_items  .='<td>'.$item['count'].'</td>';
			$order_items  .='<td>x</td>';
			$order_items  .='<td>'.$item['price'].'</td>';
			$order_items  .='<td>'.$total_prod.'</td>';		 	 
			$order_items .='</tr>'; 
		}

	  if($data['delivery_cost']>0) {

		  $order_items  .='<tr>';
		  $order_items  .='<td colspan="4">'.getVar('delivery').'</td>';
		  
		  $order_items  .='<td>'.$data['delivery_cost'].'</td>';		 	 
		  $order_items .='</tr>'; 

		  $total+=$data['delivery_cost'];

	  }

  
	   $order_items  .='<tr>';
		$order_items  .='<td colspan=4><b>'.$L->Str('Total price') .'</b></td>';
		$order_items  .='<td><b>'.($total) .'</b></td>';
		$order_items .='</tr>'; 
		$order_items  .='</table>';
								  
		$body = str_replace('%%order_items%%',$order_items,$body);
	   $order_url = SERVER.'/order/view.php?id='.$data['number'];
	   $body=str_replace('%%order_url%%',$order_url,$body);
		
		$body = Tools_Email::emailBody($body);                             
	   $result = Tools_Email::sendMail($data['email'],$subject,$body,1);	 	 	 	 
		   
   
   }
	 public function sendSMS($phone,$message) {
		 		 
		 		 	include $_SERVER['DOCUMENT_ROOT'].'/includes/Traffic_SMS.php';
		 		 	Traffic_SMS::Init('ba320f3480d5eccd5b7ed0c867b9f01b9d18a765');		 		 		 		 	
		 		 
		 		 	$phone = str_replace('+371','',$phone);
		 		  	$phone = trim($phone);
		 		 	$phones=array($phone);		 		 			
		 		 			 		 		 		 	
		 		 	$arr = Traffic_SMS::SendMany($phones, 'EUROLED.LV', $message);		 		 			 		 	
		 	
		 		 		  		 		 
		        	return true;	
	}
	
		 
	public function deleteOrder($id) {
		$this -> db -> Exec("DELETE FROM goods_orders_data WHERE orderid = ".$id);
		$this -> db -> Exec("DELETE FROM goods_orders WHERE id = ".$id);
	}
	

	public function isUnique($number) {

		$array = $this->db2->where('number',$number)->getOne('goods_orders');

		if(empty($array))
			return true;
		else
			return false;

	}	

	private function genNumber() {

		$number = Tools_Text::getRandomNumber(6);
		$number ='E'.Tools_Text::getRandomLetters(1).$number;	
		return $number;
	}	


	private function getNumber() {

		$number = $this->genNumber();
		
		while(!$this->isUnique($number))
			$number = $this->genNumber();

		return $number;

	}	
	
	public function createOrder($userid) {
		
		$number = $this->getNumber();	

		$sql = "INSERT INTO goods_orders SET created_ip='".Tools_Http::getIP()."', created=NOW(), userid=".$userid." , number = '".$number."', def_lang='".$this->lang_id."' ";

		$this -> db -> exec($sql);
		$id = $this->db->lastId();

		$this->changeStatus($id,0);



		return $id;
	}

	public function addDelivery($orderid,$delivery,$value,$comment,$delivery_address='',$client_card='',$delivery_cost=0,$payment=0,$country_id=0) {


		$input = array(

			'client_card'=>$client_card,
			'delivery'=>$delivery,
			'value'=>$value,
			'delivery_cost'=>$delivery_cost,
			'delivery_address'=>$delivery_address,
			'payment'=>$payment,
			'comment'=>$comment,
			'country_id'=>$country_id,


		);

		$this->db2->where('id',$orderid);
		$this->db2->update('goods_orders',$input);

	}
	
	public function loadUser($id) {
	
		$sql = "SELECT * FROM users WHERE id='".$id."' ";
		$user = $this -> db -> getArray($sql);
		return $user;
	}
	
	public function insertUser($email) {
	
		$sql = "INSERT INTO users SET auth_email='".$email."' ";
		$this -> db -> Exec($sql);
		$id = $this->db->lastId();
		return $id;
	}
	
	public function checkUser($email) {
	
		$sql_1='SELECT id FROM users WHERE auth_email="'.$email.'"';
 		$row_sql_1=$this->db->Exec($sql_1);
		list($id)=$this->db->FetchRow($row_sql_1);
		
		if(!$id)
			$id = $this->insertUser($email);
		
		return $id;
	
	}
	
	public function saveUser($id,$email,$name,$surname,$phone, $delivery_address) {

	$sql = "UPDATE users SET email='".$email."',name='".$name."',surname='".$surname."',phone='".$phone."', address='".$delivery_address."' WHERE id = ".$id;
	$this -> db -> Exec($sql);

	}
	
	public function check_price($product_id,$catid=0,$price=0,$count=0) {

	if(!$catid) {
	$sql_1='SELECT catid FROM goods WHERE id='.$product_id;
 	$row_sql_1=$this->db->Exec($sql_1);
	list($catid)=$this->db->FetchRow($row_sql_1);
	}

    $sql='SELECT p.level_id FROM pricelevels AS p LEFT JOIN pricelevels_values as v ON p.level_id=v.level_id
    	WHERE (p.start<='.$count.'  AND (p.end>='.$count.' || p.end=0 || p.end<='.$count.' )) AND v.price>0 
    	AND cat_id='.$catid.'   	
    	ORDER BY start DESC LIMIT 1';  	  	
    $row_sql=$this->db->Exec($sql);
    list($level_id)=$this->db->FetchRow($row_sql);
    

    if($level_id) {
    
     $sql='SELECT price FROM pricelevels_values WHERE level_id='.$level_id.' AND product_id='.$product_id;
     $row_sql=$this->db->Exec($sql);

     list($price_level)=$this->db->FetchRow($row_sql);

	
     if($price_level)   return $price_level;
     else   return $price;
     
  
    } else { 
       
    return $price;
    
    }
	
	}
	
	public function addLine($orderid, $id, $cnt) {
		
		$products = new Products();
		$orders = new Products_Orders();
		$item = $products->getItem($id);
		if (!empty($item)) {
			$price = $item['price'];
			$price_2 = $item['price_2'];
			$price=$orders->check_price($id,$item['catid'],$price,$cnt);
			
			$sql = 
			"INSERT INTO goods_orders_data 
			SET 
			free_shipping =".$item['free_shipping'].", 
			orderid = ".$orderid.", 
			product_id = ".$id.", 
			price = ".Tools_Common::formatPrice($price).", 
			price_2 = ".Tools_Common::formatPrice($price_2).", 
			`count` = ".$cnt.",
			`ean` = '".$item['ean']."',
			`vendor_code` = '".$item['code']."' ";

			$this -> db -> Exec($sql);
		
		}
	}
	
	public function getOrderByNumber($number) {

		$array = $this->db2->where('number',$number)->getOne('goods_orders');

		if(!empty($array)) {

			return $this->getOrder($array['id']);
		} else
			return array();
	
	}	

	public function getOrderItems($id) {		

		$vars = '
		g.id, 
		g.title, 
		o.price, 
		o.count, 
		g.code,						
		go.delivery_address,
		go.delivery,
		go.value as delivery_type,
		u.name,
		u.surname,
		u.email,
		u.phone,
		u.address,
		o.free_shipping,

		d.code as delivery_code,
		o.count*o.price as total,
		l.translation as title_lang	
		';


		$this->db2->join('goods g','g.id=o.product_id','LEFT');
		$this->db2->join('goods_orders go','go.id = o.orderid','LEFT');
		$this->db2->join('goods_users u','u.id = go.userid','LEFT');
		$this->db2->join('delivery as d','d.id = go.delivery','LEFT');
		$this->db2->join('languages_texts as l','l.type="goods" AND col="title" AND objectid = o.product_id AND lang="'.$this->lang.'" ','LEFT');
		$this->db2->where('o.orderid',$id);
		$array = $this->db2->get('goods_orders_data o',NULL,$vars);
	
		foreach($array as $key =>$arr) {
			
			$array[$key]['title'] = $arr['title_lang'] ? $arr['title_lang'] : $arr['title'];

		}	

		return $array;

	}	

	public function isCancelled($id) {

		$data = $this->getOrder($id);

		if(!empty($data) && $data['status']==$this->cancelled)
			return true;
		else
			return false;
	}

	public function getStatusListSimple() {
	
		return $this->status;	
	}

	public function getStatusList() {
	
		$array = array();
		foreach($this->status as $key => $name) 	
			$array[$key] = array(
					'id'=>$key,
					'name'=>$name,
					'ord'=>$this->status_order[$key],
					'alias'=>$this->statusAliases[$key],
					'color'=>$this->status_colors[$key]
					);	 
		
	  uasort($array, function ($item1, $item2) {
			return $item1['ord'] <=>  $item2['ord'];
		});

		return $array;			
}

	public function getHolidays() {

		$dates = array();
	
		$dates[]='10.04.'.date('y');
		$dates[]='12.04.'.date('y');
		$dates[]='13.04.'.date('y');
		$dates[]='01.05.'.date('y');
		$dates[]='04.05.'.date('y');
		$dates[]='23.06.'.date('y');
		$dates[]='24.06.'.date('y');
		$dates[]='18.11.'.date('y');
		$dates[]='24.12.'.date('y');
		$dates[]='25.12.'.date('y');
		$dates[]='26.12.'.date('y');
		$dates[]='31.12.'.date('y');	
		$dates[]='01.01.'.(date('y')+1);

		return $dates;

	}	

	public function checkHoliday($delivery_date) {

		$dates = $this->getHolidays();
		foreach($dates as $date) {

			if(date('d.m.y',$delivery_date)==$date) {	
					$delivery_date+=60*60*24*1;
			}

		}

		return $delivery_date;
	}

	public function getPaymentDate($date) {

		$date = strtotime($date)+(60*60*24*$this->payment_term);
		if(7-date('N', $date)<=1) {
			 $date+=60*60*24*(8-date('N', $date));
	 } 

	 $date = $this->checkHoliday($date);

		return $date;

	}

	public function getShippingMethod($id) {  


		return isset($this->shipping_methods[$id]) ? $this->shipping_methods[$id] : array();
	
	}
	
	public	function getShippingName($id,$lang_id) {  


		$data =  isset($this->shipping_methods[$id]) ? $this->shipping_methods[$id] : array();

		if(!empty($data)) {

			return getVar($data['code'],$lang_id);
		}
	}	


	public function getStatusName($id) {
	
		return isset($this->status[$id]) ? $this->status[$id] : getVar('removed'); 
	}
	 
	 public function getStatusTime($order_id,$status_id) {

		$this->db2->orderBy('time','DESC');
		$this->db2->where('order_id',$order_id);
		$this->db2->where('status_id',$status_id);
		$data = $this->db2->getOne($this->dbname_status_log);

		return !empty($data) ? $data['time'] : 0; 

}	
	
	public function getList (array $fields = array(), array $params = array()){
		$result = array();

		$statuses = $this->getStatusList();

		
		
		$default_params = array (
			'limit' => true,
			'offset' => 0,
			'length' => 10,
			'order' => 'id DESC'
		);
		$params = $params + $default_params;
		$where = "";
		
		if (!empty($fields)){
			$tmp = array();
			foreach ($fields as $key => $value) {
				if (is_array($value)) {
					$tmp[] = ' goods_orders.'.$key.' IN ('.implode(',',$value).') ';
				} elseif (strstr($value,'%')) {
					$tmp[] = ' goods_orders.'.$key.' LIKE \''.$value.'\'';
				} else {
					$tmp[] = ' goods_orders.'.$key.' = \''.$value.'\' ';
				}
			}
			
			$where = implode(' AND ',$tmp);
			unset($tmp);
		}
		
		$limit_str = "";
		if ($params['limit']) {
			$row_c = $this -> db -> getRowCount("goods_orders",$where);
			$limit_str = $this -> db -> getPagingQuery ($params['length'],$row_c, $params['offset']);
		}
		
		$main_sql = "SELECT goods_users.*,goods_orders.*, goods_orders.id AS orderid,p.status as payment_status,p.time as payment_time,delivery_cost FROM goods_orders
		LEFT JOIN payments p ON p.id = goods_orders.payment_id
		LEFT JOIN goods_users ON goods_orders.userid=goods_users.id WHERE 1=1 ".($where?" AND ".$where : "");
		 
		$params['order']="created DESC";
		 
		$sql = $main_sql." ORDER BY goods_orders.".$params['order']." ".$limit_str;
		
		$cres = $this -> db -> Exec($main_sql);
		$total_rows = $this -> db -> Count($cres);
		
		$res = $this -> db -> Exec($sql);
		$rows = $this -> db -> Count($res);
		if ($rows) {
			for ($i=0;$i<$rows;$i++) {
				$row = $this -> db -> Fetch($res);
				
				$total = $this -> db -> Exec("SELECT SUM(price) AS total_price, COUNT(*) AS total_count, SUM(`count`) AS positions  FROM goods_orders_data WHERE orderid = ".$row['orderid']);
				$total_r = $this -> db -> Fetch($total);
				
				$first_pr = $this->db->Exec("SELECT g.title, g.id FROM goods_orders_data o LEFT JOIN goods g ON g.id=o.product_id WHERE o.orderid=".$row['orderid']." ORDER BY o.id ASC LIMIT 1");
				$first_pr = $this -> db -> Fetch($first_pr);
				
				$row['first_product'] = $first_pr;
				$row['total_price'] = $total_r['total_price'];
				$row['total_count'] = $total_r['total_count'];
				$row['positions'] = $total_r['positions'];
				$row['discount'] = 0;
				
				/* $total_sum = 0;
				$sql = "SELECT price * `count` AS c FROM goods_orders_data WHERE orderid = ".$row['orderid'];
				$res2 = $this -> db -> Exec($sql);
				$rows2 = $this -> db -> Count($res2);
				for ($j=0;$j<$rows2;$j++) {
					$price_row = $this -> db -> Fetch ($res2);
					$total_sum += $price_row['c'];

				} */
				$this->db2->where('orderid',$row['orderid']);	
				$total_sum = $this->db2->getValue('goods_orders_data','SUM(price*`count`)');

				//echo $row['orderid'].' '.$total_sum.'<br>';

				$row['total_products'] = $total_sum;
				$row['totals'] = $total_sum+$row['delivery_cost'];
				$row['status_data'] =isset($statuses[$row['status']]) ? $statuses[$row['status']] : array();	
		   


				if($row['payment_id']) {

					$row['payment_status'] = $this->paymentStatuses[$row['payment_status']];
					$row['payment_status']['name'] = getVar($row['payment_status']['code']);
					$row['is_paid'] = $row['payment_status']['paid'];
					
				} else { 
					$row['payment_status'] = array();
					$row['is_paid'] = false;
				}	

				$result[] = $row;
			}
		}
		
		return array('data'=>$result, 'total'=>$total_rows);
	}

	public function getCouriers()  {

		if(empty($this->couriers))
			$this->couriers = $this->db2->map('id')->get('delivery_couriers');
	
		return $this->couriers;
		}
	 


	public function getOrder($id) {
		
		$statuses = $this->getStatusList();
		$couriers = $this->getCouriers();
		$shipping = $this->getShippingMethods();
		$payments = $this->getPaymentMethods();	


		$data = $this -> getList(array('id'=>$id), array('limit'=>false));
		$data = $data['data'];

		if (!empty($data)) {
			$data = $data[0];
			
			$data['status_data'] =isset($statuses[$data['status']]) ? $statuses[$data['status']] : array();	
		    $data['datetime'] = date('d.m.y H:i',strtotime($data['created']));		
		   	$data['date_short'] = date('d.m.y',strtotime($data['created']));		
			$data['payment_name'] = $this->payments[$data['payment']];

			if($data['delivery']==1)
				$data['no_delivery'] = 1;
			else
				$data['no_delivery'] =0;
				 

			$data['shipping_method'] = $shipping[$data['delivery']];	
			$data['payment_text'] = $this->getPaymentMethod($data['payment']);
		   	$data['payment_term'] = $this->payment_term;

			$data['is_finished'] = $data['status']==$this->finished ? 1 : 0;
			$data['is_cancelled'] = $data['status']==$this->cancelled ? 1 : 0;
			
			$data['is_awaiting_payment'] = $data['status_data']['alias']== 'awaiting_payment' ? 1 : 0;
			
			$data['date'] = $data['created'];
			$data['is_paid'] = false;


		    /* 
			$data['courier_name'] = isset($couriers[$data['shipping_courier_id']]['name']) ? $this->couriers[$data['shipping_courier_id']]['name'] : '';

			if($data['shipping_courier_id'] && isset($couriers[$data['shipping_courier_id']])) {
				$data['courier_info']  = $couriers[$data['shipping_courier_id']]; 
				$data['tracking_url'] = str_replace('%%tracking%%',$data['shipping_tracking_number'],$data['courier_info']['tracking_url']);
		 	}	*/   
			 

			$data['delivery_data'] = array();
			$data['paid'] = 0;
 			
			$paid_time = $this->getStatusTime($data['id'],$this->paid);
   
			if($paid_time) { 	
	   
				$data['delivery_data'] = Products_Delivery::getInstance()->getDate($data['delivery'],$data['country_id'],0,$paid_time);
				$data['paid'] = $paid_time;
				
			} 
   
			if($data['status']==$this->shipping) {
				
				$status_time = $this->getStatusTime($data['id'],$this->shipping);
   
				if($status_time) {
   
					$data['delivery_data'] = Products_Delivery::getInstance()->getDate($data['delivery'],$data['country_id'],0,$status_time);
					$data['shipped'] = 1;
   
				} 
			}

			$data['products'] = $this->getOrderItems($id);
			$data['payment_date'] = date('d.m.y',$this->getPaymentDate($data['created']));
		   	
			$data['total'] = $data['totals'];

			return $data;
		} else return array();
	}

	public function getProductsTable($array,$lang) {

		$products_text = '<table class="products"  cellpadding=0 cellspacing = 0>';	
 
 
		 $products_text .="<tr>
					 
					 
					   <td style='background:#ececec;font-weight:bold;padding:5px;'>".getVar('code',$lang)."</td>
					   <td style='background:#ececec;font-weight:bold;padding:5px;'>".getVar('name',$lang)."</td>
					   <td style='background:#ececec;font-weight:bold;padding:5px;'>".getVar('qnt',$lang)."</td>
					   <td style='background:#ececec;font-weight:bold;padding:5px;text-align:center'>".getVar('price',$lang)."</td>
					   <td style='background:#ececec;font-weight:bold;padding:5px;text-align:center'>".getVar('total',$lang)."</td>";
 
		foreach($array['products'] as $i => $product) { 
		$products_text .= "<tr>
										  
							 <td style='padding:10px;border-right:1px dotted #c1c1c1;'>".$product['code']."</td>                         
							 <td style='padding:10px;border-right:1px dotted #c1c1c1;'>".$product['title']."</td>
							 <td style='width:20px;text-align:center;border-right:1px dotted #c1c1c1;'> ".$product['count']."</td>
							 <td style='text-align:center;border-right:1px dotted #c1c1c1;' nowrap> <span style='display:block;margin:0 10px;'> ".$product['price']."</span> </td>
							 <td style='text-align:center;border-right:1px dotted #c1c1c1;' nowrap> <span style='display:block;margin:0 10px;'>".number_format($product['total'],2,".","")." </span></td>
							</tr>\r\n";
	 }                           	
	 $products_text .= '</table>';
 
	 return $products_text;
 
 
  }

	public function getPaymentMethod($id,$lang='') {

		$data = $this->getPaymentMethods();
	
		$array = $data[$id];
	
		if($lang)
			$array ['name'] = getVar($array ['code'],$lang);
	
	
	
		return $array;
	
		}


	public function getInvoice($id,$download=0) {

		if($id) {
	 
		  $data = $this->getOrder($id,1);    
		  $words = invoice_words::getInstance();
		  $user = users::getInstance()->get_user($data['id_user']);    
		  $author = users::getInstance()->get_user($data['status_user']);
	
		  //print_r($data);
		  
		  $array['options']	= $this->options;
		  $array['document_number'] = $data['number'];
		  $array['date_output'] = date('d.m.y',strtotime($data['date']));
		  $array['date_due_output']  = $data['payment_date'];
		  $array['date'] = strtotime($data['date']); 
	   
		  $array['buyer_name'] = $data['firm_name'];
		  $array['buyer_person'] = $data['person_name'];
		  $array['buyer_reg'] = $user['ur_regnomer'];
		  $array['buyer_vat'] = $user['ur_pvn'];
		  $array['buyer_address'] = $user['ur_adres_1'].','.$user['ur_sity'].','.$user['ur_index'].','.$user['country'];
		  
		  $delivery_address = array();
		  if($data['shipping']==2) {
			  $delivery_address[]=$data['adres'];
			  $delivery_address[]=$data['city'];
			  $delivery_address[]=$data['index'];
			  $delivery_address[]=$data['country'];
		   } 
			  
		  $array['delivery_address'] =  !empty($delivery_address) ? implode(',',$delivery_address) : '';
		  $array['buyer_account'] = $user['nomer_sh'];
		  $array['buyer_bank'] = $user['bank'];
		  $array['buyer_swift'] = $user['kod_banka'];
		  
		  $array['total_quantity'] = $data['total_quantity'];
		  $array['subtotal'] = $data['total'];
		  $array['total'] = $data['total_vat'];
		  $array['vat'] = $data['vat']; 	  
		  $array['total_products'] = $data['total_products'];
		  $array['transport'] = '';
		  $array['special']='';    
		  $array['amount_words'] = $words->vardiem($array['total']);;
		  $array['comment'] = '';                
		  $array['created_by'] = $author['person_name'];
		  $array['discount'] = $data['discount'];
		  $array['delivery'] = $data['delivery'];
	
		  //print_r($array);
	
	
		  foreach($data['products'] as $row) {
		  
				  $item = array();
				  $item['ean'] = $row['ean'];
				  $item['vendor_code'] = $row['vendor_code'];
				  $item['name'] = $row['name'];
				  $item['quantity'] = $row['kol'];
				  $item['price'] = $row['cena'];
				  $item['sub_total'] = $row['total'];
				  $array['items'][]=$item;							
		  }
		  
		  
		  //print_r($array['options']);
		  
		  $name = $array['options']['company_name'].'-'.getVar('invoice_head2',$user['def_lang']).'-'.$array['document_number'].'.pdf';					
		  $invoice = new Invoice($user['def_lang']);
	
		  //